using System;
using System.IO;
using System.Net;
using System.Text.RegularExpressions;
using System.Collections;

public class NagiosStatus {

    public string host;
    public string service;
    public string status;


    public NagiosStatus( string host, string service, string status ) {
        this.host = host;
        this.service = service;
        this.status = status;
    }   
}

public class CSNagios {

    public ArrayList GetNagiosStatus( Uri uri, String username, String password ) {
        WebRequest req = WebRequest.Create( uri );
        req.Credentials = new NetworkCredential( username, password );
        WebResponse res = req.GetResponse();

        ArrayList result = new ArrayList();
    
        using ( StreamReader reader = new StreamReader( res.GetResponseStream())) {
            string [] lines = Regex.Split( reader.ReadToEnd(), "\n" );

            string host = "";
            string service = "";
            string status = "";

            Regex re =  new Regex( @"host=(?<host>.*)&service=(?<service>.*)'" );
        
            foreach( string line in lines ) {
                if ( line.IndexOf("extinfo.cgi") > 0 ) {
                    Match m = re.Match( line );
                    if (m.Success) {
                        host = m.Groups["host"].Captures[0].ToString();
                        service = m.Groups["service"].Captures[0].ToString();
                    }
                } else if ( line.IndexOf( "status" ) > 0 ) {
                    bool found = false;
                    if ( line.IndexOf( "statusOK" ) > 0 ) {
                        status = "OK";
                        found = true;
                    } else if ( line.IndexOf( "statusWARNING" ) > 0 ) {
                        status = "WARNING";
                        found = true;
                    } else if ( line.IndexOf( "statusCRITICAL" ) > 0 ) {
                        status = "CRITICAL";
                        found = true;
                    }
                    
                    if ( found ) {  
                        result.Add( new NagiosStatus( host, service, status ));
       
                    }
                }
            }
        }
        return result;
    }
}
